#include "SoftwareSerial.h"
//------------------------------------------------
SoftwareSerial mySerial(2,3);   // Lien série vers DFPLayer, broches 2 et 3 utilisées, anciennement 10,11
#define Start_Byte 0x7E
#define Version_Byte 0xFF
#define Command_Length 0x06
#define Acknowledge 0x00
#define End_Byte 0xEF
#define ACTIVATED LOW

boolean isPlaying = false;

//------------------------------------------------
void setup(){
  Serial.begin(115200);
  mySerial.begin (9600);
  delay(1000);
}
//------------------------------------------------

void loop () 
{ 
 playFirst();
 Serial.println("Premiere Piste");
 delay(3000);
 
 Pause();
 Serial.println("Pause");
 delay(3000);
 
 play();
 Serial.println("Reprend la lecture");
 delay(3000);
 
 playNext();
 Serial.println("Piste Suivante");
 delay(4000);
 
 setVolume(20);
 Serial.println("Volume à 20");
 delay(2000);

 setVolume(10);
 Serial.println("Volume à 10");
 delay(2000);

 setVolume(30);
 Serial.println("Volume à 30");
 delay(2000);
 
 playTrack(1,4);
 Serial.println("Dossier 01, Piste #4");
 delay(3000);
 
 playTrack(1,3);
 Serial.println("Dossier 01, Piste #3");
 delay(3000);
  
 playTrack(2,1);
 Serial.println("Dossier 02, Piste #1");
 delay(3000);

 Serial.println("On boucle!");
}

//------------------------
void playFirst()
{
  execute_CMD(0x0F,1,1); // Sélectionne la chanson 01 du dossier 01
  delay(100);
  setVolume(30);
}

//------------------------
void Pause()         
{
  execute_CMD(0x0E,0,0);
  delay(200);
}

//------------------------
void play()   // Reprend après une pause
{
  execute_CMD(0x0D,0,0); 
  delay(200);
}

//------------------------
void playNext()
{
  execute_CMD(0x01,0,0);
  delay(500);
}

//------------------------
void playPrevious()
{
  execute_CMD(0x02,0,0);
  delay(500);
}

//------------------------
void setVolume(int volume)
{
  execute_CMD(0x06, 0, volume); // Set the volume (0x00~0x30)
  delay(500);
}

//------------------------  
void playTrack(byte FloderNo, byte TrackNo)
{
  Pause();
  execute_CMD(0x0F, FloderNo, TrackNo); // Sélectionne le dossier donné et la piste donnée
  delay(500);
}

//------------------------
void execute_CMD(byte CMD, byte Par1, byte Par2)
  // Excecute the command and parameters
{
  // Calculate the checksum (2 bytes)
  word checksum = -(Version_Byte + Command_Length + CMD + Acknowledge + Par1 + Par2);
  // Build the command line
  byte Command_line[10] = {Start_Byte, Version_Byte, Command_Length, CMD, Acknowledge, Par1, Par2, highByte(checksum), lowByte(checksum), End_Byte}; //7E FF 06 0D 00 00 01 XX XX EF
  //Send the command line to the module
  for (byte k=0; k<10; k++)
  {
    mySerial.write( Command_line[k]);
  }
}
